SystemOrganization addCategory: #'Iliad-More-CometExample'!

ILApplication subclass: #ILCometCounterApplication
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-CometExample'!

!ILCometCounterApplication classSide methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 17:56'!
path
	^'examples/comet'! !

!ILCometCounterApplication methodsFor: 'controllers' stamp: 'sa 4/16/2010 17:59'!
index
	^[:e |
		e 
			build: self cometConnection;
			build: counter]! !

!ILCometCounterApplication methodsFor: 'initialization' stamp: 'sa 4/16/2010 17:59'!
initialize
	super initialize.
	counter := ILCometCounter new! !

!ILCometCounterApplication methodsFor: 'building' stamp: 'SebastienAudier 1/4/2011 15:44'!
updatePage: aPage
	super updatePage: aPage.
	aPage head stylesheet href: '/stylesheets/iliad.css'! !

ILWidget subclass: #ILCometCounter
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-CometExample'!

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:14'!
contents
	^[:e |
		e h1: counter count printString.
		e a action: [self increase]; text: '++'.
		e a action: [self decrease]; text: '--']! !

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/17/2010 17:52'!
decrease
	counter decrease.
	self markDirty.
	self triggerCometEvent: ILCometCounterChangedEvent new! !

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/17/2010 17:52'!
increase
	counter increase.
	self markDirty.
	self triggerCometEvent: ILCometCounterChangedEvent new! !

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 5/3/2010 17:59'!
initialize
	super initialize.
	counter := ILCometCounterModel instance.
	self subscribeToCometEvent: ILCometCounterChangedEvent! !

ILWidget subclass: #ILCometCounterModel
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-CometExample'!

ILCometCounterModel class
	instanceVariableNames: 'instance'!

!ILCometCounterModel classSide methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:03'!
instance
	instance ifNil: [instance := self new].
	^instance
	! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:04'!
count
	^count! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:05'!
decrease
	count := count - 1! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:05'!
increase
	count := count + 1! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:04'!
initialize
	super initialize.
	count := 0! !

ILCometEvent subclass: #ILCometCounterChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-CometExample'!
